*******************
*                 *
*    M O R S E    *
*                 *
*******************
*
 ORG $0800
*
TAPE MAC
 LDA CSIN
 TAX
 EOR OLD
 STX OLD
 EOM
*
DELAY EQU 16
LOWER EQU 4
UPPER EQU 140
*
ACC EQU $00
PAGE EQU $01
PTRL EQU $02
PTRH EQU $03
D1 EQU $04
D2 EQU $05
*
LEN1 EQU $06
LEN2 EQU $07
LEN3 EQU $08
FREQ EQU $09
*
CHARS EQU LEN3
*
XSAV EQU $01
YSAV EQU $02
*
APPEND EQU LEN3
COUNT EQU $18
CNTL EQU $18
CNTH EQU $19
ADRL EQU $1E
ADRH EQU $1F
*
R0 EQU $EC
R1 EQU $ED
R2 EQU $EE
R3 EQU $EF
*
A0 EQU $CA
A1 EQU $CB
A2 EQU $CC
A3 EQU $CD
A4 EQU $CE
A5 EQU $CF
A6 EQU $C9
*
OLD EQU ACC
PEAKS EQU D1
REG16 EQU D2
FRAC EQU D2
FRQ EQU LEN3
PEAKL EQU CNTL
PEAKH EQU CNTH
FLG EQU ADRL
*
FLAG EQU $FA
PAGE0 EQU $FB
PTRL0 EQU $FC
PTRH0 EQU $FD
BITS EQU $FE
DUMMY EQU $FF
*
CHRGET EQU $00B1
CHRGOT EQU $00B7
*
AMPER EQU $03F5
DOSHOOK EQU $AA53
IOBAS EQU $C000
KBD EQU $C000
KBDS EQU $C010
CSOUT EQU $C020
SPKR EQU $C030
CSIN EQU $C060
WWRAM EQU $C089
RWROM EQU $C08A
RWRAM EQU $C08B
CHKCOM EQU $DEBE
SYNERR EQU $DEC9
BASIC EQU $E000
CHRGTBYT EQU $E6F5
GETBYT EQU $E6F8
*
BOOT BIT RWRAM
 BIT RWRAM
 LDA #$FF
 STA BASIC
 CMP BASIC
 BNE ERR
 INC BASIC
 LDA BASIC
 BEQ NOERR
ERR JMP ERROR
NOERR JSR NEWZ
 LDA #$02
 STA LEN1
 LDA #$80
 STA LEN2
 LDA #$F0
 STA FREQ
 LDA #<COUT
 LDY #>COUT
 STA $36
 STY $37
 STA $9D04
 STY $9D05
 LDA #<RESET2
 STA $03F2
 LDA #>RESET2
 STA $03F3
 EOR #$A5
 STA $03F4
 LDY #$00
 LDX #$FF
BOOTLP INX
 LDA $A884,X
 BPL BOOTLP
 INY
 CPY #$16
 BCC BOOTLP
 LDA $A885,X
 AND #$80
 ORA #$20
 STA $A885,X
 CPY #$17
 BCC BOOTLP
 LDY #$4C
 CPY AMPER
 BNE SET03F5
 LDX AMPER+2
 CPX #>BOOT
 BCC GET03F5
 CPX #>PGMEND
 BCC SET03F5
GET03F5 LDA AMPER+1
 STA JMP03F5+1
 STX JMP03F5+2
SET03F5 LDA #<BEGIN
 LDX #>BEGIN
 STY AMPER
 STA AMPER+1
 STX AMPER+2
 LDX #>PGMEND
SETBAS LDA #$00
 STA $F1
 STA $F2
 STA $F3
 STA $A4
 STA $54
 STA $D6
 STA $D8
 STA $7A
 STA $14
 STA $67
 STX $68
 STA $B8
 STX $B9
 STA $7D
 STX $7E
 LDY #$04
SETLP STA ($67),Y
 DEY
 BPL SETLP
 STY $32
 STY $76
 INC $67
 INC $F1
 LDA #$03
 STA $8F
 STA $69
 STX $6A
 STA $6B
 STX $6C
 STA $6D
 STX $6E
 STA $AF
 STX $B0
 LDA $73
 LDX $74
 STA $6F
 STX $70
 LDA #$55
 STA $52
 RTS
ERROR BIT RWROM
 LDX #>BOOT
 JSR SETBAS
 LDA #$60
 STA AMPER
 LDY #$00
 LDA #$8D
ERRLP JSR COUT1
 LDA ERRMSG,Y
 INY
 CMP #$8D
 BNE ERRLP
COUT1 JMP (DOSHOOK)
NMI STA RWROM
 JMP ($FFFA)
RESET STA RWROM
 JMP ($FFFC)
IRQ STA RWROM
 JMP ($FFFE)
RESET2 JSR TROFFZ
 LDA #<RESET
 LDY #>RESET
 BIT WWRAM
 BIT WWRAM
 STA $FFFC
 STY $FFFD
 BIT RWROM
 JMP $9DBF
OVRFLW JMP FULLERR
TRONZ LDA FLAG
 ORA #$80
 STA FLAG
 LDA PAGE0
 BMI OVRFLW
 RTS
PRINT JSR TRONZ
 JSR CHRGET
 JSR $DAD5
TROFFZ LDA FLAG
 AND #$7F
 STA FLAG
 RTS
COUT BIT FLAG
 BPL COUTZ
 STA ACC
 STX XSAV
 STY YSAV
 LDA FLAG
 AND #$01
 BNE END
 LDA ACC
 AND #$7F
 CMP #$60
 BCC UCASE
 AND #$DF
UCASE CMP #$0D
 BEQ SPACE
 CMP #$20
 BEQ SPACE
 ASL
 TAX
 LDA CHRTAB,X
 STA D2
 LDA CHRTAB+1,X
 STA D1
 ASL D1
 ROL D2
 BCC END
 JSR PUTBIT
 ASL D1
 ROL D2
 JSR PUTBIT
DOITLP ASL D1
 ROL D2
 BCC DONE
 CLC
 JSR PUTBIT
 SEC
 JSR PUTBIT
 SEC
 JSR PUTBIT
 ASL D1
 ROL D2
 JSR PUTBIT
 JMP DOITLP
COUTZ JMP $9EBD
DONE JSR PUTBIT
 CLC
 JSR PUTBIT
 LDA FLAG
 AND #$FD
 STA FLAG
EXIT LDA PAGE0
 BNE END
 LDA PTRL0
 AND #$03
 BNE END
 JSR BELL
END LDA ACC
 LDX XSAV
 LDY YSAV
 BIT FLAG
 BVS COUTZ
 RTS
SPACE LDA FLAG
 AND #$02
 BNE END
 LDA FLAG
 ORA #$02
 STA FLAG
 CLC
 JSR PUTBIT
 CLC
 JSR PUTBIT
 CLC
 JSR PUTBIT
 SEC
 JSR PUTBIT
 JMP EXIT
PUTBIT LDX PAGE0
 BMI OKBITS
 LDA ATAB,X
 STA PTRH0
 LDA BTAB,X
 TAX
 LDA IOBAS,X
 LDA IOBAS,X
 LDX BITS
 LDY #$00
 LDA (PTRL0),Y
 AND BITTAB0,X
 BCC STABYTE
 ORA BITTAB1,X
STABYTE STA (PTRL0),Y
 BIT RWROM
 DEC BITS
 BNE OKBITS
 LDA #$08
 STA BITS
 INC PTRL0
 BNE OKBITS
 DEC PAGE0
 BMI FULLERR
OKBITS RTS
FULLERR LDA FLAG
 ORA #$01
 STA FLAG
 LDY #$00
 LDA #$8D
FULL JSR COUT1
 LDA FULLMSG,Y
 INY
 CMP #$8D
 BNE FULL
 JSR COUT1
BELL LDA #$87
 JMP COUT1
GETBIT LDX PAGE
 BMI DOCLC
 LDA ATAB,X
 STA PTRH
 LDA BTAB,X
 TAX
 LDA IOBAS,X
 LDA IOBAS,X
 LDX ACC
 LDY #$00
 LDA (PTRL),Y
 AND BITTAB1,X
 BIT RWROM
 DEC ACC
 BNE ENDGET
 LDX #$08
 STX ACC
 INC PTRL
 BNE ENDGET
 DEC PAGE
ENDGET TAX
 BEQ DOCLC
 SEC
 RTS
DOCLC CLC
 RTS
PUTCHR ORA #$80
 JSR $FDED
 DEC CHARS
 BNE NOCR
 LDA #$F0
 STA CHARS
 JSR $FD8E
NOCR BIT KBD
 BPL NOWAIT
 LDA KBD
 CMP #$83
 BEQ BREAK
 BIT KBDS
KBDWAIT LDA KBD
 BPL KBDWAIT
 CMP #$83
 BEQ BREAK
 CMP #$A0
 BEQ NOWAIT
 BIT KBDS
NOWAIT RTS
BREAK PLA
 PLA
 JMP ENDLIST
BEGIN JSR CHRGOT
 BEQ NOPARSE
 LDY #ADRTABL-COMTAB-1
PARSELP CMP COMTAB,Y
 BEQ FOUND
 DEY
 BNE PARSELP
JMP03F5 JMP SYNERR
NOPARSE LDY #$00
FOUND LDA ADRTABH,Y
 PHA
 LDA ADRTABL,Y
 PHA
 RTS
NEW JSR CHRGET
 BNE SYNTAX
NEWZ BIT WWRAM
 BIT WWRAM
 LDA #<NMI
 LDY #>NMI
 STA $FFFA
 STY $FFFB
 LDA #<RESET
 LDY #>RESET
 STA $FFFC
 STY $FFFD
 LDA #<IRQ
 LDY #>IRQ
 STA $FFFE
 STY $FFFF
 LDA #$3E
 STA PAGE0
 LDY #$00
 STY FLAG
 STY PTRL0
NEWLP LDX PAGE0
 LDA ATAB,X
 STA PTRH0
 LDA BTAB,X
 TAX
 LDA IOBAS,X
 LDA IOBAS,X
 TYA
CLRLPZ STA (PTRL0),Y
 INY
 BNE CLRLPZ
 DEC PAGE0
 BPL NEWLP
 BIT RWROM
 LDA #$3E
 STA PAGE0
 LDA #$08
 STA BITS
 RTS
TRON JSR CHRGET
 BNE SYNTAX
 LDA FLAG
 ORA #$40
 STA FLAG
 RTS
TROFF JSR CHRGET
 BNE SYNTAX
 LDA FLAG
 AND #$BF
 STA FLAG
 RTS
SYNTAX JMP SYNERR
SPEED JSR CHRGTBYT
 STX LEN1
 JSR CHKCOM
 JSR GETBYT
 STX LEN2
 JSR CHKCOM
 JSR GETBYT
 STX FREQ
 RTS
TEXT LDA #$00
 STA APPEND
 JSR CHRGET
 BEQ NOPARMS
 CMP #187 CONT
 BNE GETPARM
 DEC APPEND
 JSR CHRGET
 BNE GETPARM
NOPARMS LDA $AA60
 LDY $AA61
 STA CNTL
 STY CNTH
 LDA $AA72
 LDY $AA73
 STA ADRL
 STY ADRH
 JMP TEXTZ
GETPARM JSR $DD67
 JSR $E752
 JSR CHKCOM
 LDA $50
 LDY $51
 STA ADRL
 STY ADRH
 JSR $DD67
 JSR $E752
 JSR CHRGOT
 BNE SYNTAX
 LDA $50
 LDY $51
 STA CNTL
 STY CNTH
TEXTZ LDA CNTL
 ORA CNTH
 BEQ ILLEGAL
 CLC
 LDA ADRL
 ADC CNTL
 LDA ADRH
 ADC CNTH
 BCS ILLEGAL
 CMP #$C0
 BCS ILLEGAL
 BIT APPEND
 BVS SKIP0
 LDA FLAG
 AND #$40
 STA ACC
 JSR NEWZ
 LDA ACC
 STA FLAG
SKIP0 JSR TRONZ
TEXTLP LDY #$00
 LDA (ADRL),Y
 JSR $FDED
 INC ADRL
 BNE NOINC
 INC ADRH
NOINC LDA CNTL
 BNE NODEC
 DEC CNTH
NODEC DEC CNTL
 LDA CNTL
 ORA CNTH
 BNE TEXTLP
 JSR TROFFZ
 BIT APPEND
 BVS SKIP1
 JMP SEND
SKIP1 RTS
ILLEGAL JMP $E199
SYNTX0 JMP SYNERR
LIST JSR CHRGET
 BNE SYNTX0
LISTZ BIT KBDS
 LDA #$08
 STA ACC
 LDA #$3E
 STA PAGE
 LDA #$00
 STA PTRL
 STA CNTH
 LDA #$F0
 STA CHARS
 JSR TROFFZ
 JSR $FD8E
WAIT0 JSR GETBIT TONE/REST
 BCS LISTT TONE !
 JSR GETBIT REST -/.
 BCS WAIT1 . !
 INC CNTH - !
 INC CNTH
WAIT1 INC CNTH
 LDA CNTH
 CMP #$0C
 BCC WAIT0
 RTS
LISTT LDA #$08 TONE !
 STA CNTL
 LDA ACC
 LDX PAGE
 LDY PTRL
 STA R0
 STX R1
 STY R2
 SEC
LIST0 LDA CNTL
 BEQ TOOLONG
 ROL D1
 ROL D2
 JSR GETBIT - OR . ?
 ROL D1
 ROL D2
 DEC CNTL
 JSR GETBIT TONE/REST
 BCS LIST0 TONE !
 LDA #$00
 STA CNTH REST !
 JSR GETBIT - OR . ?
 BCC PAUSE - !
 INC CNTH . !
 JSR GETBIT TONE/REST
 BCS LIST0 TONE !
PAU0 JSR GETBIT REST -/.
 BCS PAU1
PAUSE INC CNTH
 INC CNTH
PAU1 INC CNTH
 LDA CNTH
 CMP #$0C
 BCS PAU2
 JSR GETBIT TONE/REST
 BCC PAU0 REST !
PAU2 LDX CNTL
 BEQ NOSHIFT
PAU3 ASL D1
 ROL D2
 ASL D1
 ROL D2
 DEX
 BNE PAU3
NOSHIFT LDX #$C0
SRCHLP LDA CHRTAB-2,X
 CMP D2
 BNE CONT0
 LDA CHRTAB-1,X
 CMP D1
 BEQ FND
CONT0 DEX
 DEX
 BNE SRCHLP
TOOLONG LDA R0
 LDX R1
 LDY R2
 STA ACC
 STX PAGE
 STY PTRL
 LDA #$A0
 JSR PUTCHR
 LDA #"("
 JSR PUTCHR
 JSR $FF3A BELL
LONG0 JSR GETBIT - OR . ?
 LDA #$00
 ROL
 TAX
 LDA SGNTAB,X
 JSR PUTCHR
 JSR GETBIT TONE/REST
 BCS LONG0 TONE !
 LDA #$00
 STA CNTH REST !
 JSR GETBIT - OR . ?
 BCC LONG2 - !
 INC CNTH . !
 JSR GETBIT TONE/REST
 BCS LONG0 TONE !
LONG1 JSR GETBIT REST -/.
 BCS LONG3
LONG2 INC CNTH
 INC CNTH
LONG3 INC CNTH
 LDA CNTH
 CMP #$0C
 BCS ENDLONG
 JSR GETBIT TONE/REST
 BCC LONG1 REST !
ENDLONG LDA #")"
 JSR PUTCHR
 LDA #$A0
 JSR PUTCHR
 JMP DOEND
FND DEX
 DEX
 TXA
 LSR
 CMP #')'
 BEQ PARNTSES
 CMP #$20
 BCS NOTCTRL
 STA R0
 LDA #$DE
 JSR PUTCHR
 LDA R0
 ORA #$40
NOTCTRL JSR PUTCHR
DOEND LDA CNTH
 CMP #$0C
 BCS ENDLIST
 CMP #$07
 BCC JMPLP
 LDA #$A0
 JSR PUTCHR
JMPLP JMP LISTT
PARNTSES LDA #'('
 JSR PUTCHR
 LDA #')'
 BNE NOTCTRL
ENDLIST BIT KBDS
 JMP $FD8E
NEXT INC PTRL
 INC PTRL
 BNE NXTOK
 DEC PAGE
NXTOK LDA ADRH
 CMP PAGE
 BNE NXTRTS
 LDA PTRL
 CMP ADRL
NXTRTS RTS
GETBYTE LDA R0
 LDX R1
 STA R2
 STX R3
GETBYT2 LDX PAGE
 LDA AATAB,X
 STA PTRH
 LDA BBTAB,X
 TAX
 LDA IOBAS,X
 LDA IOBAS,X
 LDY #$00
 LDA (PTRL),Y
 STA R0
 INY
 LDA (PTRL),Y
 STA R1
 BIT RWROM
 RTS
DIVIDE LDA R0
 CMP R2
 LDA R1
 SBC R3
 BCS BIGGER
 LDA R0
 LDX R1
 STA A4
 STX A5
 LDA R2
 LDX R3
 STA A0
 STX A1
 BCC DIVCONT
BIGGER LDA R0
 LDX R1
 STA A0
 STX A1
 LDA R2
 LDX R3
 STA A4
 STX A5
DIVCONT LDA #$00
 STA A2
 STA A3
 ROL
 STA A6
 LDX #$10
DIVLOOP ROL A0
 ROL A1
 ROL A2
 ROL A3
 SEC
 LDA A2
 SBC A4
 TAY
 LDA A3
 SBC A5
 BCC SMALLER
 STY A2
 STA A3
SMALLER DEX
 BNE DIVLOOP
 ROL A0
 ROL A1
 LDA A0
 LDX A1
 BEQ DIVRTS
 LDA #$FF
DIVRTS RTS
PTRSAV LDA #<RESET
 LDY #>RESET
 BIT WWRAM
 BIT WWRAM
 STA $FFFC
 STY $FFFD
 BIT RWROM
 BIT KBDS
 LDA PTRL
 STA ADRL
 CLC
 LDA PAGE
 ADC ADRH
 STA ADRH
 LDA #$00
 STA ACC
 RTS
PRTERR LDX KBD
 CPX #$83
 BEQ PRTRTS
 LDX ACC
 STA ACC
 TXA
 BNE PRTERRZ
 JSR $FD8E
PRTERRZ JSR $FF2D ERR
 LDA #"#"
 JSR $FDED
 LDA ACC
 JSR $FDE3 PRHEX
 BIT KBD
 BPL PRTRTS
 BIT KBDS
PRTWAIT LDA KBD
 BPL PRTWAIT
 CMP #$A0
 BEQ PRTRTS
 CMP #$83
 BEQ PRTRTS
 BIT KBDS
PRTRTS RTS
RESET3 LDY #$00
 LDX #$00
RESET4 DEX
 BNE RESET4
 DEY
 BNE RESET4
 PLA
 PLA
 LDA #$9D
 PHA
 LDA #$BE
 PHA
 JSR PTRSAV
 JMP PARSE
BUFFERR JSR PTRSAV
 LDA #$02
 JSR PRTERR
 JMP PARSE
TONEERR JSR PTRSAV
 LDA #$03
 JSR PRTERR
 JMP PARSE
RESTERR JSR PTRSAV
 BIT WWRAM
 BIT WWRAM
 LDY #BSYTAB-RDYTAB-1
BSYLP LDA BSYTAB,Y
 STA $D000,Y
 DEY
 BPL BSYLP
 JSR SEND
PARSE LDX ADRH
 INX
 BNE CHECKIT
 LDA ADRL
 CMP #BSYTAB-RDYTAB+2
 BEQ ONETONE
 BCS CHECKIT
 LDA #$00
 JSR PRTERR
 JSR $FD8E
 BIT KBDS
 JMP NEWZ
ONETONE LDA #$01
 JSR PRTERR
CHECKIT LDA #$FF
 STA PAGE
 LDA #BSYTAB-RDYTAB
 STA PTRL
 JSR GETBYT2
 LDA R0
 LDX R1
 STA D1
 STX D2
CHECKLP JSR NEXT
 BCS REFERR
 JSR GETBYTE
 JSR DIVIDE
 CMP #$02
 BCC CHECK2
 LDY A6
 BNE CHECK2
 CMP #$05
 BCC CHKFND
 LDA #$04
 JSR PRTERR
CHKERR JSR NEXT
 JSR GETBYT2
 JMP CHECKLP
CHECK2 JSR NEXT
 JSR GETBYT2
 JSR DIVIDE
 CMP #$02
 BCC CHECKLP
 CMP #$05
 BCC CHKFND
 LDA #$05
 JSR PRTERR
 JSR NEXT
 BCC CHKERR
REFERR LDA #$06
 JSR PRTERR
 LDA D1
 LDX D2
 JMP PARSE2
CHKFND LDA A4
 LDX A5
PARSE2 STA R2
 STX R3
 LDA #$FF
 STA PAGE
 LDA #BSYTAB-RDYTAB
 STA PTRL
PLOOP SEC
 JSR PUTBIT
 JSR GETBYT2
 JSR DIVIDE
 CMP #$02
 BCS TCONT
 LDA R0
 ADC R2
 STA R2
 LDA R1
 ADC R3
 ROR
 STA R3
 ROR R2
 SEC
 BCS WRTBIT1
TCONT LDY A6
 BNE TOK
 LDA #$07
 BNE TERR
TOK CMP #$05
 BCC WRTBIT1
 LDA #$08
TERR JSR PRTERR
 LDA A6
 EOR #$FF
 ROR
WRTBIT1 JSR PUTBIT
 JSR NEXT
 BCS LISTX
 JSR PUTBIT
 JSR GETBYT2
 JSR DIVIDE
 CMP #$02
 BCS RCONT
 LDA R0
 ADC R2
 STA R2
 LDA R1
 ADC R3
 ROR
 STA R3
 ROR R2
 SEC
 BCS WRTBIT2
RCONT LDY A6
 BNE ROK
 LDA #$09
 JSR PRTERR
 SEC
 BCS WRTBIT2
ROK CMP #$05
 BCC WRTBIT2
 CLC
 JSR PUTBIT
 CLC
 JSR PUTBIT
 CLC
 JSR PUTBIT
 CLC
 JSR PUTBIT
 SEC
WRTBIT2 JSR PUTBIT
 JSR NEXT
 JMP PLOOP
LISTX LDA #$10
 STA REG16
STOPBIT CLC
 JSR PUTBIT
 DEC REG16
 BNE STOPBIT
 LDA ACC
 BEQ LISTY
 JSR $FD8E
LISTY LDA #$FF
 STA PAGE0
 JMP LISTZ
SYNTX1 JMP SYNERR
RECV JSR CHRGET
 BNE SYNTX1
 JSR NEWZ
 LDX #ATAB-AATAB-1
INITBUF LDA #$FF
 STA AATAB,X
 LDA #<RWROM
 STA BBTAB,X
 DEX
 BNE INITBUF
 LDX #ATAB-AATAB-1
 LDY $6E
 CPY #>PGMEND
 BCS BUFOK
 LDY #>PGMEND
 BNE GOAHEAD
BUFOK LDA $6D
 BEQ GOAHEAD
BUFLP1 INY
GOAHEAD TYA
 CMP $70
 BCS BUFEND1
 CMP #$9D
 BCS BUFEND1
 STA AATAB,X
 DEX
 BNE BUFLP1
BUFEND1 STX ADRH
 BIT WWRAM
 BIT WWRAM
 LDY #BSYTAB-RDYTAB-1
RDYLP LDA RDYTAB,Y
 STA $D000,Y
 DEY
 BPL RDYLP
 JSR SEND
 LDA ADRH
 STA AALD+1
 STA BBLD+1
 EOR #$FF
 STA PAGE
 LDA #$00
 STA PEAKL
 STA PEAKH
 LDA #<RESET3
 LDY #>RESET3
 BIT WWRAM
 BIT WWRAM
 STA $FFFC
 STY $FFFD
 BIT RWROM
 JMP BLOCK
ERRMSG ASC "16K RAMCARD NOT FOUND"
 DFB $87,$8D
FULLMSG ASC "BUFFER FULL"
 DFB $8D
BITTAB0 HEX FFFEFDFBF7EFDFBF7F
BITTAB1 HEX 000102040810204080
RDYTAB HEX 9D95000000000000
BSYTAB HEX D9D5000000000000
SGNTAB HEX DFAE
COMTAB DFB 0 SEND
 DFB 191 NEW
 DFB 155 TRACE
 DFB 156 NOTRACE
 DFB 188 LIST
 DFB 135 READ
 DFB 169 SPEED=
 DFB 137 TEXT
 DFB 186 PRINT
ADRTABL DFB <SEND-1
 DFB <NEW-1
 DFB <TRON-1
 DFB <TROFF-1
 DFB <LIST-1
 DFB <RECV-1
 DFB <SPEED-1
 DFB <TEXT-1
 DFB <PRINT-1
ADRTABH DFB >SEND-1
 DFB >NEW-1
 DFB >TRON-1
 DFB >TROFF-1
 DFB >LIST-1
 DFB >RECV-1
 DFB >SPEED-1
 DFB >TEXT-1
 DFB >PRINT-1
*
*
*
* FROM ONE 'LDA CSIN'
* TO THE NEXT ONE MUST
* BE A MULTIPLE OF 24
* MACHINE CYCLES
*
 DS $1113-*
BLOCK LDA CSIN ;4
 STA OLD ;2
 LDA #BSYTAB-RDYTAB-4 ;2
 STA PTRL ;2
 LDA #$00 ;2
 STA PEAKS ;2
 STA FRAC ;2
 STA FRQ ;2
 LDY #$FF ;2
ERRFLG STY FLG ;2
 LDY #$00 ;2
FRQLP PMC TAPE ;11
 BMI FRQPEAK ;2/3
 INY  ;2
 CPY #UPPER ;2
 BCS ERRFLG ;2/3
 NOP  ;2
 BCC FRQLP ;3
CLRFLG ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 NOP  ;2
 NOP  ;2
 LDY #$00 ;2
 STY FLG ;2
 INY  ;2
 BNE FRQLP ;3
ERRPEAK ASL DUMMY ;5
 LDA DUMMY ;3
 LDA DUMMY ;3
 LDY #$FF ;2
 STY FLG ;2
 INY  ;2
 INY  ;2
 BNE FRQLP ;3
FRQLPZ ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 LDA DUMMY ;3
 LDY #$02 ;2
 BNE FRQLP ;3
FRQPEAK LDA FLG ;3
 BNE CLRFLG ;2/3
 INY  ;2
 CPY #LOWER ;2
 BCC ERRPEAK ;2/3
 CLC  ;2
 TYA  ;2
 ADC FRAC ;3
 STA FRAC ;2
 LDA #$00 ;2
 ADC FRQ ;3
 STA FRQ ;2
 INC PEAKS ;5
 BNE FRQLPZ ;3(2)
 DEC FRQ
 LDA #DELAY
 STA REG16
 BNE DOTONE
TONE LDY #$00 ;2
 LDA PEAKL ;3
 STA (PTRL),Y ;6
 STY PEAKL ;2
 INC PTRL ;5
 LDA PEAKH ;3
 STA (PTRL),Y ;6
 STY PEAKH ;2
 INC PTRL ;5
 BNE OKPAG ;2/3
 DEC PAGE ;5
 BNE OKPAGE ;3
 JMP BUFFERR
OKPAG LDA DUMMY ;3
 CLC  ;2
 BCS OKPAGE ;2
OKPAGE LDA #DELAY ;2
 STA REG16 ;2
 LDY FRQ ;3
 DEY  ;2
 DEY  ;2
 BNE TONELP ;3
*
*   36+4+58=98
*
DOTONE LDY FRQ ;3
TONELP PMC TAPE ;11
 BPL NOPEAK ;2/3
 LDA #DELAY ;2
 STA REG16 ;2
 NOP  ;2
 DEY  ;2
 BNE TONELP ;2/3
 NOP  ;2
 NOP  ;2
 BEQ INCPEAK ;3
NOPEAK DEY  ;2
 BNE GOTONE ;2/3
 DEC REG16 ;5
 BEQ REST ;2(3)
 ASL DUMMY ;5
INCPEAK INC PEAKL ;5
 BNE GODOIT ;2/3
 INC PEAKH ;5
 BNE DOTONE ;3
 JMP TONEERR
GOTONE CLC  ;2
 BCC TONELP ;3
GODOIT NOP  ;2
 NOP  ;2
 BNE DOTONE ;3
TONEZ JMP TONE ;3
REST LDX PAGE ;3
AALD LDA AATAB,X ;4
 STA PTRH ;2
BBLD LDA BBTAB,X ;4
 TAX  ;2
 LDA IOBAS,X ;4
 LDA IOBAS,X ;4
 LDY #$00 ;2
 LDA PEAKL ;3
 STA (PTRL),Y ;6
 INC PTRL ;5
 LDA PEAKH ;3
 STA (PTRL),Y ;6
 INC PTRL ;5
 STY PEAKL ;2
 STY PEAKH ;2
 STY PEAKS ;2
 LDA #DELAY ;2
 STA REG16 ;2
 CLC  ;2
*
*     26+65+7=98
*
 LDY FRQ ;3
 DEY  ;2
 DEY  ;2
RESTLP PMC TAPE ;11
 BMI REST1 ;2/3
 BPL REST0 ;3
REST0 BPL REST2 ;3
REST1 INC PEAKS ;5
REST2 DEY  ;2
 BNE RESTLP ;2/3
 LDA PEAKS ;3
 BEQ SILENT ;2/3
 DEC REG16 ;5
 BEQ TONEZ ;2(4)
 LDA #$00 ;2
 STA PEAKS ;2
 SEC  ;2
PEAKINC INC DUMMY ;5
 LDA DUMMY ;3
 LDA DUMMY ;3
 LDY FRQ ;3
 DEY  ;2
 INC PEAKL ;5
 BNE GOREST ;2/3
 INC PEAKH ;5
 BNE RESTLP ;3
 JMP RESTERR
SILENT BCS NOCLR ;2/3
 LDA DUMMY ;3
 LDA #DELAY ;2
 STA REG16 ;2
 BCC PEAKINC ;3
NOCLR NOP  ;2
 NOP  ;2
 CLC  ;2
 BCC PEAKINC ;3
GOREST NOP  ;2
 NOP  ;2
 BNE RESTLP ;3
SEND LDA LEN1
 BEQ ZEROERR
 CMP #$55 $55*3=$FF
 BCC OK
 LDA #$55
 BNE OKZ
ZEROERR LDA #$01
OKZ STA LEN1
OK ASL
 CLC
 ADC LEN1
 STA LEN3
 LDA FREQ
 ASL
 STA L1+1
 LDA #>WAIT/2
 ROL
 STA L1+2
 LDA #$3E
 STA PAGE
 LDY #$00
 STY PTRL
 STY COUNT
LOOP1 LDX PAGE ;3
 LDA ATAB,X ;4
 STA PTRH ;2
 LDA BTAB,X ;4
 TAX  ;2
 LDA IOBAS,X ;4
 LDA IOBAS,X ;4
 LDA (PTRL),Y ;5
 BEQ QUIT ;2
 STA ACC ;2
 LDX #$04 ;2
LOOP2 ASL ACC ;5
 BPL LONG ;2/3
SHORT LDA LEN1 ;3
 BNE CONT ;3
LONG LDA LEN3 ;3
 BEQ CONT ;2
CONT STA D1 ;2
L0 LDA LEN2 ;3
 STA D2 ;2
L1 JSR WAIT ;11+13*(256-FREQ)
 BCS LOUD ;2/3
QUIET LDA CSIN ;4
 LDA CSIN ;4
 BCC L2 ;3
LOUD LDA CSOUT ;4
 LDA SPKR ;4
 BCC L2 ;2
L2 DEC D2 ;5
 BNE CORR3 ;2/3
 DEC D1 ;5
 BNE L0 ;3
*
* FREQUENCY = 511500/(44+13*(256-FREQ))
*
* FREQ = 256-INT((511500/FREQUENCY-44)/13)
*
 ASL ACC ;5
 DEX  ;2
 BNE CORR2 ;2/3
 INY  ;2
 BNE CORR1 ;2/3
 DEC PAGE ;5
 BPL LOOP1 ;3
QUIT BIT RWROM
 RTS
CORR1 NOP  ;2
 NOP  ;2
 BNE LOOP1 ;3
CORR2 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 ASL DUMMY ;5
 CLC  ;2
 BCC LOOP2 ;3
CORR3 LDA #$00 ;2
 STA DUMMY ;2
 STA DUMMY ;2
 LDA DUMMY ;3
 BEQ L1 ;3
AATAB DS $0100-$3F
ATAB HEX FEFDFCFBFAF9F8
 HEX F7F6F5F4F3F2F1F0
 HEX EFEEEDECEBEAE9E8
 HEX E7E6E5E4E3E2E1E0
 HEX DFDEDDDCDBDAD9D8
 HEX D7D6D5D4D3D2D1D0
 HEX DFDEDDDCDBDAD9D8
 HEX D7D6D5D4D3D2D1D0
WAIT INC COUNT
 INC COUNT
 INC COUNT
 INC COUNT
 INC COUNT
 INC COUNT
 INC COUNT
 INC COUNT
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
 HEX E618E618E618E618
WAITLP DEC COUNT
 BNE WAITLP
 RTS
 HEX 00
 ASC "VERSION 1.0"
 HEX 8D
 ASC "APPLE //+"
 HEX 8D
 ASC "COPYRIGHT (C) 1985 BY"
 HEX 8D
 ASC "STEFFEN BEYER"
 HEX 8D
CHRTAB DDB %1110101110000000 @
 DDB %1110111000000000 A
 DDB 0 B
 DDB %1010101000000000 C
 DDB 0 D
 DDB %1111101111000000 E
 DDB 0 F
 DDB 0 G
 DDB 0 H
 DDB 0 I
 DDB 0 J
 DDB 0 K
 DDB 0 L
 DDB 0 M
 DDB %1010111010000000 N
 DDB %1010101100000000 O
 DDB 0 P
 DDB 0 Q
 DDB 0 R
 DDB %1111111011100001 S
 DDB 0 T
 DDB %1111101000000000 U
 DDB %1111111011000001 V
 DDB %1110111111000001 W
 DDB 0 X
 DDB 0 Y
 DDB 0 Z
 DDB 0 ESC
 DDB 0 /
 DDB 0 ]
 DDB 0 ^
 DDB 0 -
* SIGNS
 DDB 0 SPC
 DDB 0 !
 DDB %1110111110110000 "
 DDB 0 #
 DDB 0 $
 DDB 0 %
 DDB 0 &
 DDB %1110101010110000 '
 DDB %1011101011100000 (
 DDB %1011101011100000 )
 DDB 0 *
 DDB 0 +
 DDB %1010111110100000 ,
 DDB %1011111111100000 -
 DDB %1110111011100000 .
 DDB %1011111011000000 /
 DDB %1010101010000000 0
 DDB %1110101010000000 1
 DDB %1111101010000000 2
 DDB %1111111010000000 3
 DDB %1111111110000000 4
 DDB %1111111111000000 5
 DDB %1011111111000000 6
 DDB %1010111111000000 7
 DDB %1010101111000000 8
 DDB %1010101011000000 9
 DDB %1010101111110000 :
 DDB %1011101110110000 ;
 DDB %1011101110000001 <
 DDB %1011111110000000 =
 DDB %1110111011000001 >
 DDB %1111101011110000 ?
* LETTERS
 DDB 0 @
 DDB %1110000000000000 A
 DDB %1011111100000000 B
 DDB %1011101100000000 C
 DDB %1011110000000000 D
 DDB %1100000000000000 E
 DDB %1111101100000000 F
 DDB %1010110000000000 G
 DDB %1111111100000000 H
 DDB %1111000000000000 I
 DDB %1110101000000000 J
 DDB %1011100000000000 K
 DDB %1110111100000000 L
 DDB %1010000000000000 M
 DDB %1011000000000000 N
 DDB %1010100000000000 O
 DDB %1110101100000000 P
 DDB %1010111000000000 Q
 DDB %1110110000000000 R
 DDB %1111110000000000 S
 DDB %1000000000000000 T
 DDB %1111100000000000 U
 DDB %1111111000000000 V
 DDB %1110100000000000 W
 DDB %1011111000000000 X
 DDB %1011101000000000 Y
 DDB %1010111100000000 Z
 DDB %1110111000000000 AE
 DDB %1010101100000000 OE
 DDB %1111101000000000 UE
 DDB 0 ^
 DDB %1111101011100000 -
BBTAB DS $0100-$3F
BTAB HEX 83838383838383
 HEX 8383838383838383
 HEX 8383838383838383
 HEX 8383838383838383
 HEX 8383838383838383
 HEX 8383838383838383
 HEX 8B8B8B8B8B8B8B8B
 HEX 8B8B8B8B8B8B8B8B
PGMEND EQU *
----------------------------------
/----------------------------------

Textfile T.MORSE
